<?php

// security check
if ( !defined( 'WP_PLUGIN_DIR') )
{
	die("There is nothing to see here.");
}

// Small info on DashBoard-page
function counterize_dashboard_callback()
{
	$admin = dirname($_SERVER['SCRIPT_FILENAME']);
	$admin = substr($admin, strrpos($admin, '/') + 1);
	$count = counterize_getamount();
	$unique = counterize_getuniqueamount();
	$todaycount = counterize_gethitstoday();
	$online = counterize_get_online_users();
	$todayunique = counterize_getuniquehitstoday();

	?>
		<p><?php _e('Total: ','counterize'); ?> <strong><?php echo $count; ?></strong> <?php _e('hits and ','counterize')?> <strong><?php echo $unique; ?></strong> <?php _e(' unique.'); ?><br />
		<?php _e('Today: ','counterize'); ?><strong><?php echo $todaycount; ?></strong> <?php _e('hits and ','counterize'); ?><strong><?php echo $todayunique; ?></strong><?php _e(' unique.'); ?><br />
		<?php _e('Currently: ','counterize'); ?><strong><?php echo $online; ?></strong><?php _e(' users online.','counterize'); ?></p>
		<a href='admin.php?page=counterize_dashboard'><?php _e('Detailed view', 'counterize'); ?> &raquo;</a>
	<?php
}

//Content of the Counterize dashboard page
function counterize_display_dashboard_page_callback()
{
	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . '</h2>
	';

	//Show charts
	counterize_showStats(true);

	if( current_user_can( 'manage_options' ) )
	{

		$updateText = "";
		if ( isset( $_GET['killmass'] ) && check_admin_referer( "action_killmass" ) )
		{
			if ($_GET['killmass']=='yes')
			{
				if (isset($_POST['counterize_killemall']))
				{
					foreach ($_POST['counterize_killemall'] as $key => $val)
					{
						counterize_killEntry($val);
						$updateText .= __('Entry: '.$val.' removed<br />','counterize');
					}
					counterize_updateText($updateText);
				}
			}
		}

		// For the zap-an-entry-option
		if ( isset( $_GET['kill'] ) && check_admin_referer( "action_uri_kill" ) )
		{
			counterize_killEntry($_GET['kill']);
			counterize_updateText(__("Deleting entry ", "counterize") . $_GET['kill']);
		}

		//Show latest entries
		counterize_show_history( "counterize_dashboard", false );
	}

	//Print the footer
	counterize_pagefooter();
}


function counterize_display_dashboard_traffic_page_callback()
{
	$width = 250;
	$amount2 = 0;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Traffic" ,'counterize') . '</h2>
	';

	counterize_show_data_traffic( true, $width, $amount2, true );

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_pages_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Popular pages" ,'counterize') . '</h2>
	';

	counterize_show_data_pages( true, $width, $amount2, true );

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_ip_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("IP addresses" ,'counterize') . '</h2>
	';

	counterize_show_data_ip( true, $width, $amount2, true);

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_referers_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Referers" ,'counterize') . '</h2>
	';

	counterize_show_data_referers( true, $width, $amount2, true);

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_browsers_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Browsers" ,'counterize') . '</h2>
	';

	counterize_show_data_browsers(       true, $width, $amount2, true);

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_os_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Operating systems" ,'counterize') . '</h2>
	';

	counterize_show_data_os( true, $width, $amount2, true);

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_keywords_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("Keywords" ,'counterize') . '</h2>
	';

	counterize_show_data_keywords( true, $width, $amount2, true);

	//Print the footer
	counterize_pagefooter();
}

function counterize_display_dashboard_history_page_callback()
{
	// Amount to pass as option to the graphs...
	$amount2 = counterize_get_option('amount2');
	if ($amount2 == "" || $amount2 == " " || !is_numeric($amount2))
	{
		$amount2 = 10;
	}
	$width = 250;

	echo '
	<div id="icon-plugins" class="icon32"></div>
	<h2>' . __("Counterize", 'counterize') . " - " . __("Dashboard" ,'counterize') . " - " . __("History" ,'counterize') . '</h2>
	';

	if( current_user_can( 'manage_options' ) )
	{

		$updateText = "";
		if ( isset( $_GET['killmass'] ) && check_admin_referer( "action_killmass" ) )
		{
			if ($_GET['killmass']=='yes')
			{
				if (isset($_POST['counterize_killemall']))
				{
					foreach ($_POST['counterize_killemall'] as $key => $val)
					{
						counterize_killEntry($val);
						$updateText .= __('Entry: '.$val.' removed<br />','counterize');
					}
					counterize_updateText($updateText);
				}
			}
		}

		// For the zap-an-entry-option
		if ( isset( $_GET['kill'] ) && check_admin_referer( "action_uri_kill" ) )
		{
			counterize_killEntry($_GET['kill']);
			counterize_updateText(__("Deleting entry ", "counterize") . $_GET['kill']);
		}

		//Show latest entries
		counterize_show_history( "counterize_dashboard_history",  true );
	}

	//Print the footer
	counterize_pagefooter();
}

?>