<?php

// security check
if ( !defined( 'WP_PLUGIN_DIR') || !current_user_can( 'manage_options' ) )
{
	die("There is nothing to see here, sorry.");
}

// Used for first-time initialization
// create tables if not present...
function counterize_install($vermaj, $vermin, $verrev)
{
	//update_option('counterize_logbots', "disabled");

	$MajorVersion = get_option('counterize_MajorVersion');
	if ($MajorVersion === FALSE)
	{
		$MajorVersion = counterize_get_version('major');
		$MinorVersion = counterize_get_version('minor');
		$Revision     = counterize_get_version('revision');
	}
	else
	{
		$MajorVersion = get_option('counterize_MajorVersion', 1);
		$MinorVersion = get_option('counterize_MinorVersion', 0);
		$Revision     = get_option('counterize_Revision'    , 0);
	}


	global $wpdb;

	if($MajorVersion < 2)
	{
		$sql = 'SHOW TABLES LIKE \'' . counterize_logTable() . '\'';
		$results = $wpdb->query($sql);

		if ($results == 0)
		{
			// Update to Version 1
			$sql = "CREATE TABLE `". counterize_logTable() . "` (
				id INTEGER NOT NULL AUTO_INCREMENT,
				`IP` VARCHAR(16) NOT NULL,
				`timestamp` DATETIME NOT NULL,
				url VARCHAR(255) NOT NULL DEFAULT 'unknown',
				referer VARCHAR(255) NOT NULL DEFAULT 'unknown',
				useragent TEXT,
				PRIMARY KEY(id)
			)";

			$results = $wpdb->query($sql);
		}

		// update to Version 2
		$sql = "ALTER TABLE `" . counterize_logTable() . "` ADD `pageID` INT( 11 ) NOT NULL;";
		$wpdb->query($sql);

		$sql = "ALTER TABLE `" . counterize_logTable() . "` ADD `agentID` INT( 11 ) NOT NULL;";
		$wpdb->query($sql);

		$sql = "ALTER TABLE `" . counterize_logTable() . "` ADD `refererID` INT( 11 ) NOT NULL;";
		$wpdb->query($sql);

		$sql = "CREATE TABLE `" . counterize_pageTable() . "` (
			`pageID` INT(11) NOT NULL AUTO_INCREMENT,
			`url` VARCHAR(255) NOT NULL,
			`count` INT(11) NOT NULL DEFAULT '1',
			`postID` BIGINT(20) DEFAULT NULL,
			PRIMARY KEY (`pageID`),
			KEY `url` (`url`),
			KEY `count` (`count`)
			)";
		$wpdb->query($sql);

		$sql ="CREATE TABLE `" . counterize_refererTable() . "` (
			`refererID` INT(11) NOT NULL AUTO_INCREMENT,
			`name` VARCHAR(255) NOT NULL,
			`count` INT(11) NOT NULL DEFAULT '1',
			PRIMARY KEY (`refererID`),
			KEY `name` (`name`),
			KEY `count` (`count`)
			)";
		$wpdb->query($sql);

		$sql = "CREATE TABLE `" . counterize_agentsTable() . "` (
			`agentID` INT(11) NOT NULL AUTO_INCREMENT,
			`name` VARCHAR(255) NOT NULL,
			`count` INT(11) NOT NULL DEFAULT '1',
			PRIMARY KEY (`agentID`),
			KEY `name` (`name`),
			KEY `count` (`count`)
			) ";
		$wpdb->query($sql);

		$sql = "INSERT INTO `" . counterize_pageTable() . "` (url,count)
			SELECT
			url, COUNT(url)
			FROM `" . counterize_logTable() . "`
			GROUP BY url;";
		$wpdb->query($sql);

		$sql = "INSERT INTO `" . counterize_refererTable() . "` (name,count)
			SELECT
			referer, COUNT(referer)
			FROM `" . counterize_logTable() . "`
			GROUP BY referer;";
		$wpdb->query($sql);

		$sql = "INSERT INTO `" . counterize_agentsTable() . "` (name,count)
			SELECT
			useragent, COUNT(useragent)
			FROM `" . counterize_logTable() . "`
			GROUP BY useragent;";
		$wpdb->query($sql);

		$entries = $wpdb->get_results("SELECT * FROM " . counterize_logTable());
		foreach ($entries as $entry)
		{
			$pageID = $wpdb->get_var("SELECT pageID FROM `" . counterize_pageTable() . "` WHERE url='" . $entry->url . "'");
			$agentID = $wpdb->get_var("SELECT agentID FROM `" . counterize_agentsTable() . "` WHERE name='" . $entry->useragent . "'");
			$refererID = $wpdb->get_var("SELECT refererID FROM `" . counterize_refererTable() . "` WHERE name='" . $entry->referer . "'");
			if (!$pageID)
				$pageID = "null";
			if (!$agentID)
				$agentID = "null";
			if (!$refererID)
				$refererID = "null";
				$sql = "UPDATE `" . counterize_logTable() . "` SET pageID = {$pageID}, agentID = {$agentID}, refererID = {$refererID} WHERE id = " . $entry->id;
				$wpdb->query($sql);
		}

		$sql = "ALTER TABLE `" . counterize_logTable() . "` DROP `url`;";
		$wpdb->query($sql);

		$sql = "ALTER TABLE `" . counterize_logTable() . "` DROP `useragent`;";
		$wpdb->query($sql);

		$sql = "ALTER TABLE `" . counterize_logTable() . "` DROP `referer`;";
		$wpdb->query($sql);

		$MajorVersion = 2;
		$MinorVersion = 0;
		$Revision     = 0;
	}

	if($MajorVersion < 3)
	{


		// now we have Version 2
		if($MinorVersion < 4)
		{
			update_option('counterize_whois', 'http://ws.arin.net/cgi-bin/whois.pl?queryinput=');

			$sql = "CREATE TABLE `" . counterize_keywordTable() . "` (
				`keywordID` INT(11) NOT NULL AUTO_INCREMENT,
				`keyword` VARCHAR(255) NOT NULL,
				`count` INT(11) NOT NULL DEFAULT '1',
				PRIMARY KEY (`keywordID`),
				KEY `keyword` (`keyword`)
				);";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_refererTable() . "` ADD `keywordID` INT( 11 ) NOT NULL ;";
			$wpdb->query($sql);

			$referers = $wpdb->get_results("SELECT * FROM `" . counterize_refererTable() . "`");
			foreach ($referers as $referer)
			{
				$keywordID = counterize_getKeywordID($referer->name);
				$wpdb->query("UPDATE " . counterize_refererTable() . " SET keywordID = {$keywordID} WHERE refererID=" . $referer->refererID);
				$wpdb->query("UPDATE " . counterize_keywordTable() . " SET count = count + " . $referer->count . " WHERE keywordID=" . $keywordID);
			}
		}

		if($MinorVersion < 8)
		{
			update_option('counterize_maxWidth', 50);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `browserName` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `browserCode` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `browserVersion` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `osName` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `osCode` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `osVersion` VARCHAR( 255 ) NOT NULL ;";
			$wpdb->query($sql);
		}

		if($MinorVersion < 12)
		{
			$sql = "ALTER TABLE `" . counterize_logTable() . "` ADD INDEX ( `timestamp` );";
			$wpdb->query($sql);
		}

		if($MinorVersion < 13)
		{
			//commented to avoid users of Counterize II < 2.13 to see their precious IP data converted to a MD5 hash
			//$sql = "UPDATE `" . counterize_logTable() . "` SET IP=SUBSTR(MD5(IP),1,16);";
			//$wpdb->query($sql);
		}

		if($MinorVersion < 15)
		{

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `browserURL` VARCHAR( 255 ) NOT NULL AFTER `browserVersion` ;";
			$wpdb->query($sql);

			$sql = "ALTER TABLE `" . counterize_agentsTable() . "` ADD `osURL` VARCHAR( 255 ) NOT NULL AFTER `osVersion` ;";
			$wpdb->query($sql);

			counterize_update_all_userAgents();
		}

		$MajorVersion = 3;
		$MinorVersion = 0;
		$Revision     = 0;

	}



	//now we have version 3!
	if ($MajorVersion == 3)
	{
		if ($MinorVersion == 0)
		{
			if ( $Revision < 3 )
			{
				// default to 50 because a value of 0 leads to out of memory errors after some time.
				update_option('counterize_amount', 50);
			}

			/*if ( $Revision < 10 )
			{
				//There was an issue with the botlist.txt being not found, so some bots made it to the Counterize DB. Now we delete them.
				counterize_delete_bots();
			}*/

			if ( $Revision < 12 )
			{
				//we update the old option system to the new one

				//create the new options
				$newoptions['amount'] = get_option('counterize_amount', 50);
				$newoptions['amount2'] = get_option('counterize_amount2', 50);
				$newoptions['maxwidth'] = get_option('counterize_maxWidth', 50);
				$newoptions['excludedusers'] = get_option('counterize_excluded_users', 1);
				$newoptions['excludedip'] = get_option('counterize_excluded', '192.168.1.1,127.0.0.1');
				if ($newoptions['excludedip'] === FALSE || $newoptions['excludedip'] == '')
				{
					$newoptions['excludedip'] = '192.168.1.1,127.0.0.1';
				}
				$newoptions['logbots'] = get_option('counterize_logbots', 'disabled') == 'disabled' ? 0 : 1;
				$newoptions['whois'] = get_option('counterize_whois', 'http://www.ripe.net/whois?form_type=simple&amp;searchtext=');
				$newoptions['enableip'] = 0;
				$newoptions['flushdb'] = '';
				$newoptions['refreshua'] = '';
				$newoptions['deletebots'] = '';


				//add the new options
				add_option('counterize_options', $newoptions);
				add_option('counterize_version', "{$vermaj}.{$vermin}.{$verrev}");

				//delete the old unused options
				delete_option('counterize_amount');
				delete_option('counterize_amount2');
				delete_option('counterize_maxWidth');
				delete_option('counterize_excluded_users');
				delete_option('counterize_excluded');
				delete_option('counterize_logbots');
				delete_option('counterize_whois');

				delete_option('counterize_MajorVersion');
				delete_option('counterize_MinorVersion');
				delete_option('counterize_Revision');
			}

			if ($Revision < 13)
			{
				/*update the database */

				//add a field
				$sql = "ALTER TABLE `" . counterize_logTable() . "` ADD `haship` VARCHAR( 16 ) NOT NULL AFTER `IP` ;";
				$wpdb->query($sql);

				//define a new hash when an IP address is in the IP field
				$sql = "UPDATE `" . counterize_logTable() . "` SET `haship`=SUBSTR(MD5(`IP`),1,16) WHERE INSTR(`IP`, '.') > 0 ;";
				$wpdb->query($sql);

				//copy the current hash from the IP field if it's not an IP in the IP field
				$sql = "UPDATE `" . counterize_logTable() . "` SET `haship`=`IP` WHERE INSTR(`IP`, '.') = 0 ;";
				$wpdb->query($sql);

				//set a default value for the previous md5 ips
				$sql = "UPDATE `" . counterize_logTable() . "` SET `IP`='unavailable' WHERE INSTR(`IP`, '.') = 0;";
				$wpdb->query($sql);
			}

			if ($Revision < 16)
			{
				counterize_set_option('display_dashboard_capability', 'manage_options');
			}
			if ($Revision < 17)
			{
				//botlist.txt has been updated
				counterize_delete_bots();
			}

			if ($Revision < 18)
			{
				counterize_set_option('geoip', 'http://whatismyipaddress.com/ip/');
			}
		}
	}


	//force to update the user agents table
	counterize_update_all_userAgents();

	// Set new Version
	update_option('counterize_version', "{$vermaj}.{$vermin}.{$verrev}");

}
?>
